
var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('autocopy.');
var boolOptions = [
	'PasteOnMiddleClick', 'DeselectAfterCopy', 'StatusBar', 'EditMenuItem',
	'ContextMenuItem', 'EnableInTextBoxes', 'CopyWithoutFormatting',
	'StatusbarBlink', 'ContextMenu', 'KeyboardShortcutEnabled',
	'KeyboardShortcutKeyAccel', 'KeyboardShortcutKeyMeta',
	'KeyboardShortcutKeyCtrl', 'KeyboardShortcutKeyShift',
	'KeyboardShortcutKeyAlt'
]

function initialize() {
	
	sizeToContent();
	
	for each (var i in boolOptions) {
		var value = prefs.getBoolPref('opt' + i);
		document.getElementById('autocopy' + i).checked = value;
	}
	
	value = prefs.getIntPref('optContextMenuHideTimeout');
	document.getElementById('autocopyContextMenuHideTimeout').value = value;
	value = prefs.getCharPref('optKeyboardShortcutKey');
	document.getElementById('autocopyKeyboardShortcutKey').value = value;
	
	var firefox = navigator.userAgent.match(/Firefox/i);
	document.getElementById('autocopyEditMenuItem').setAttribute('hidden', !firefox);
	document.getElementById('autocopyContextMenuItem').setAttribute('hidden', !firefox);
	
	shortcutChange();
	
}

function save() {
	
	for each (var i in boolOptions) {
		var value = document.getElementById('autocopy' + i).checked;
		prefs.setBoolPref('opt' + i, value);
	}
	
	value = document.getElementById('autocopyKeyboardShortcutKey').value;
	prefs.setCharPref('optKeyboardShortcutKey', value);
	value = document.getElementById('autocopyContextMenuHideTimeout').value;
	prefs.setIntPref('optContextMenuHideTimeout', value);
	
}

function autocopy_validateContextTimeout() {
	var element = document.getElementById('autocopyContextMenuHideTimeout');
	return (!isNaN(parseInt(eliment.value)) && (element.value >= 0));
}

var shortcutFields = ['Accel', 'Meta', 'Ctrl', 'Shift', 'KeyAlt', ''];

function shortcutChange() {
	
	var prefix = 'autocopyKeyboardShortcutKey';
	var element = document.getElementById('autocopyKeyboardShortcutEnabled');
	var state = element.checked;
	
	for each (var i in shortcutFields) {
		element = document.getElementById(prefix + i);
		element.disabled = !state;
	}
	
}
