
var gautocopy_lastSelection = null;
var gautocopy_hidemenu_timer = null;
var gautocopy_clipboardcontents = new Array();
var gautocopy_doPaste = false;

// Add event listeners

window.addEventListener("load", function() { initAutoCopyStatus(); }, false);
window.addEventListener("mouseup", autocopyOnMouseUp, false);
window.addEventListener("keyup", autocopy_onKeyUpCheck, false);
window.addEventListener("mousedown", Autocopy_Pasteonmiddleclick_mousedown, false);
window.addEventListener("mouseup", Autocopy_Pasteonmiddleclick_mouseup, false);

// Preferences handling

var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
var autocopyPrefs = prefService.getBranch("autocopy.");
if (!autocopyPrefs.prefHasUserValue("StatusBarState")) {
	autocopyPrefs.setIntPref("StatusBarState", 1)
}

// Backwards compatibility for wrongly spelled option name
if (autocopyPrefs.prefHasUserValue('optCopyWithoutFormating') && !autocopyPrefs.prefHasUserValue('optCopyWithoutFormatting')) {
	autocopyPrefs.setBoolPref('optCopyWithoutFormatting', autocopyPrefs.getBoolPref('optCopyWithoutFormating'));
}

function AutoCopy_PreferenceListener() {
	this.observe = function(subject, topic, data) {
		if (topic != 'nsPref:changed') return;
		initAutoCopyStatus();
	};
	autocopyPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
	autocopyPrefs.addObserver('', this, false);
}

var AutoCopy_listener = new AutoCopy_PreferenceListener();
var AutoCopy_modes = ['ContextMenu', 'PasteOnMiddleClick', 'DeselectAfterCopy', 'EnableInTextBoxes', 'StatusbarBlink'];

// Some helper functions

function AutoCopy_isInput(target) {
	return target.toString().match(/InputElement|TextAreaElement/i)
}

function AutoCopy_toggle(option) {
	var opt = document.getElementById('autocopy-statusbar-' + option);
	if (!opt) return;
	var val = !autocopyPrefs.getBoolPref('opt' + option);
	autocopyPrefs.setBoolPref('opt' + option, val);
	opt.setAttribute('checked', val);
}

function AutocopyClipboardContents(type, data, len) {
	this.dataType = type;
	this.data = data;
	this.dataLength = len;
}

function autocopyContextHide(e) {
	
	var cm = gContextMenu;
	var ctxmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');
	
	if (autocopyPrefs.getBoolPref("optContextMenuItem")) {
		ctxmenuitem.hidden = (cm.onImage);
		//|| cm.onLink || cm.onImage || cm.onTextInput );
	} else {
		ctxmenuitem.hidden = true;
	}
	
	if (ctxmenuitem.hidden) {
		document.getElementById('autocopy-firebirdcontextmenuitemseparator').hidden = true;
	} else {
		document.getElementById('autocopy-firebirdcontextmenuitemseparator').hidden = false;
		autocopy_context_onpopupshowing(e);
	}
	
}

function setAutoCopyStatus() {
	
	if (!autocopyPrefs.getBoolPref("optStatusBar")) {
		return;
	}
	
	var status = document.getElementById('autocopy-status');
	var image = document.getElementById('autocopy-status-image');
	var tooltip = document.getElementById('autocopy-tooltip-value');
	
	if (!status || !image) {
		return;
	}
	
	image.setAttribute("src", "chrome://autocopy/skin/enabled.png");
	var strings = document.getElementById("autocopyStrings");
	tooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
	
}

function initAutoCopyStatus() {
	
	document.getElementById("cmd_selectAll").setAttribute("oncommand", "goDoCommand('cmd_selectAll'); AutocopySelectAll();");
	var strings = document.getElementById("autocopyStrings");
	
	var lcPrefs = prefService.getBranch("extensions.{0FED7D55-65D4-47b6-A6DE-9A4ADB55355F}.");
	var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	str.data = strings.getString("autocopy-description");
	lcPrefs.setComplexValue("description", Components.interfaces.nsISupportsString, str);
	
	// Make sure the status bar panel is in the right state
	
	var panel = document.getElementById('autocopy-statuspanel');
	var button = document.getElementById('autocopy-status');
	var image = document.getElementById('autocopy-status-image');
	var tooltip = document.getElementById('autocopy-tooltip-value');
	if (button && image) {
		
		if (autocopyPrefs.getBoolPref("optStatusBar")) {
			if (panel.collapsed) {
				panel.collapsed = false;
			}
		} else if (!panel.collapsed) {
			panel.collapsed = true;
		}
		
		if ((autocopyPrefs.getIntPref("StatusBarState") == 0) && autocopyPrefs.getBoolPref("optStatusBar")) {
			state = 'disabled';
		} else {
			state = 'enabled';
		}
		
		button.setAttribute("status", state);
		image.setAttribute("src", "chrome://autocopy/skin/" + state + ".png");
		tooltip.setAttribute("value", strings.getString("statusbar-tooltip-" + state));
		
	}
	
	var menuitem = document.getElementById('autocopy-firebirdmenuitem');
	var separator = document.getElementById('autocopy-firebirdmenuitemseparator');
	if (menuitem) {
		
		if (autocopyPrefs.getIntPref("StatusBarState") == 0) {
			menuitem.setAttribute("checked", false);
		} else {
			menuitem.setAttribute("checked", true);
		}
		
		hidden = !autocopyPrefs.getBoolPref('optEditMenuItem');
		separator.setAttribute('hidden', hidden);
		menuitem.setAttribute('hidden', hidden);
		
	}
	
	var ctxmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');
	if (ctxmenuitem && document.getElementById("contentAreaContextMenu")) {
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", autocopyContextHide, false);
	}
	
	// Activate key bindings
	
	var enable_key = null;
	if (document.getElementById('firebirdkey-toggle-autocopyenabled'))
		enable_key = document.getElementById('firebirdkey-toggle-autocopyenabled');
	
	if (document.getElementById('mozillakey-toggle-autocopyenabled'))
		enable_key = document.getElementById('mozillakey-toggle-autocopyenabled');
	
	if (document.getElementById('thunderbirdkey-toggle-autocopyenabled'))
		enable_key = document.getElementById('thunderbirdkey-toggle-autocopyenabled');
	
	if (enable_key && autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled")) {
		
		var modifiers = "";
		if (autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAccel"))
			modifiers += ",accel";
		if (autocopyPrefs.getBoolPref("optKeyboardShortcutKeyMeta"))
			modifiers += ",meta";
		if (autocopyPrefs.getBoolPref("optKeyboardShortcutKeyCtrl"))
			modifiers += ",control";
		if (autocopyPrefs.getBoolPref("optKeyboardShortcutKeyShift"))
			modifiers += ",shift";
		if (autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAlt"))
			modifiers += ",alt";
		
		modifiers.replace(/^\,/,"");
		var key = autocopyPrefs.getCharPref("optKeyboardShortcutKey");
		if (key.match(/^[A-Z]$/i)) {
			enable_key.setAttribute("key", key);
			enable_key.setAttribute("keycode", "");
		} else {
			enable_key.setAttribute("key", "");
			enable_key.setAttribute("keycode", key);
		}
		
		enable_key.setAttribute("modifiers", modifiers);
		enable_key.setAttribute("disabled", false);
		
	} else if (!autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled")) {
		enable_key.setAttribute("disabled", true);
	}
	
	// Set status bar option states
	
	for each (var i in AutoCopy_modes) {
		var opt = document.getElementById('autocopy-statusbar-' + i);
		if (!opt) continue;
		opt.setAttribute('checked', autocopyPrefs.getBoolPref('opt' + i));
	}
	
}

function switchautocopystatusstate() {
	if (autocopyPrefs.getIntPref("StatusBarState") == 0) {
		autocopyPrefs.setIntPref("StatusBarState", 1);
	} else {
		autocopyPrefs.setIntPref("StatusBarState", 0);
	}
	initAutoCopyStatus();
}

function autocopy_onKeyUpCheck(e) {
	if (e.keyCode == e.DOM_VK_A && e.ctrlKey) {
		autocopyOnMouseUp(e);
	}
}

function autocopyOnMouseUp(e) {
	
	if ((e.ctrlKey) && (!e.keyCode)) {
		return;
	}
	
	if (autocopyPrefs.getIntPref('StatusBarState') != 1) {
		return;
	}
	
	var targetclassname = e.target.toString();
	if (targetclassname.match(/SelectElement|OptionElement/i)) {
		return;
	}
	
	var editable = Autocopy_isTargetEditable(e.target);
	if (editable && !autocopyPrefs.getBoolPref('optEnableInTextBoxes')) {
		return;
	}
	
	var selection = autocopy_getSelection();
	if ((selection.length == 0) || (gautocopy_lastSelection == selection)) {
		return;
	}
	
	gautocopy_lastSelection = selection;
	autocopy_saveclipboard();
	
	if (!editable && autocopyPrefs.getBoolPref('optCopyWithoutFormatting')) {
		copyplaintext(); // Doesn't work in text boxes
	} else {
		goDoCommand('cmd_copy');
	}
	
	if (autocopyPrefs.getBoolPref('optStatusbarBlink')) {
		AutocopyBlinkStatusbarButton(3);
	}
	
	if (autocopyPrefs.getBoolPref('optContextMenu')) {
		
		var x = e.screenX;
		var y = e.screenY;
		
		if (x == 0 && y == 0) {
			document.popupNode = document.documentElement;
			x = document.documentElement.boxObject.x;
			y = document.documentElement.boxObject.y + 100;
		} else {
			document.popupNode = null;
		}
		
		document.getElementById('autocopy-context-menu').showPopup(document.documentElement, x, y, 'context');
		autocopy_timedhidemenu();
		
	}
	
	if (autocopyPrefs.getBoolPref('optDeselectAfterCopy')) {
		Autocopy_DeselectAfterCopy();
	}
	
}

function AutocopySelectAll() {
	
	if (autocopyPrefs.getIntPref("StatusBarState") != 1) {
		return;
	}
	
	var targetclassname = "";
	if (document.commandDispatcher.focusedElement) {
		targetclassname = document.commandDispatcher.focusedElement.toString();
	}
	
	if (targetclassname.match(/SelectElement|OptionElement/i)) {
		return;
	}
	
	if (!(autocopy_getSelection().length > 0)) {
		return;
	}
	
	if (!Autocopy_isTargetEditableDispatcher(document.commandDispatcher)) {
		
		gautocopy_lastSelection = autocopy_getSelection();
		autocopy_saveclipboard();
		
		if (autocopyPrefs.getBoolPref("optCopyWithoutFormatting")) {
			copyplaintext();
		} else {
			goDoCommand('cmd_copy');
		}
		
	} else if (autocopyPrefs.getBoolPref("optEnableInTextBoxes")) {
		
		if (gautocopy_lastSelection == autocopy_getSelection()) {
			return;
		}
		
		gautocopy_lastSelection = autocopy_getSelection();
		autocopy_saveclipboard();
		// Copy Plain Text doesn't work in textboxes
		goDoCommand('cmd_copy');
		
	}

	if (autocopyPrefs.getBoolPref("optStatusbarBlink")) {
		AutocopyBlinkStatusbarButton(3);
	}
	
	if (autocopyPrefs.getBoolPref("optContextMenu")) {
		document.popupNode = document.documentElement;
		document.getElementById('autocopy-context-menu').showPopup(document.documentElement, document.documentElement.boxObject.x, document.documentElement.boxObject.y + 100, "context");
		autocopy_timedhidemenu();
	}
	
	if (autocopyPrefs.getBoolPref("optDeselectAfterCopy")) {
		Autocopy_DeselectAfterCopy();
	}
	
}


function Autocopy_Pasteonmiddleclick_mousedown(e) {
	
	if (autocopyPrefs.getIntPref("StatusBarState") != 1) {
		return;
	}
	
	if (e.ctrlKey || !autocopyPrefs.getBoolPref("optPasteOnMiddleClick")) {
		return;
	}
	
	if (e.button != 1) {
		return;
	}
	
	gautocopy_doPaste = false;
	
	if (e.target.inputField && AutoCopy_isInput(e.target.inputField)) {
		gautocopy_doPaste = true;
	}
	
	if (e.target.mTextbox && e.target.mTextbox.inputField && AutoCopy_isInput(e.target.mTextbox.inputField)) {
		gautocopy_doPaste = true;
	}
	
	if (Autocopy_isTargetEditable(e.target)) {
		gautocopy_doPaste = true;
	}
	
	if (gautocopy_doPaste && getBrowser().mCurrentBrowser.autoscrollEnabled) {
		getBrowser().mCurrentBrowser.stopScroll();
	}
	
}

function Autocopy_Pasteonmiddleclick_mouseup(e) {
	
	if (autocopyPrefs.getIntPref("StatusBarState") != 1) {
		return;
	}
	
	if (e.ctrlKey || !autocopyPrefs.getBoolPref("optPasteOnMiddleClick")) {
		return;
	}
	
	if (e.button != 1) {
		return;
	}
	
	if (gautocopy_doPaste) {
		goDoCommand('cmd_paste');
	}
	
}

function Autocopy_isTargetEditable(target) {
	
	if (target) {
		
		if (AutoCopy_isInput(target)) {
			return true;
		}
		
		if (target.toString().match(/object XUL/i) && target.textbox.value) {
			return true;
		}
		
		if (target.textbox) {
			return true;
		}
		
	}
	
	if (target.ownerDocument.designMode && target.ownerDocument.designMode.match(/on/i)) {
		return true;
	}
	
	return false;
	
}

function Autocopy_isTargetEditableDispatcher(commandDispatcher) {
	
	if (commandDispatcher.focusedElement && AutoCopy_isInput(commandDispatcher.focusedElement)) {
		return true;
	} else if (commandDispatcher.focusedWindow.document.designMode && commandDispatcher.focusedWindow.document.designMode.match(/on/i)) {
		return true;
	}
	
	return false;
	
}

function Autocopy_DeselectAfterCopy() {
	
	if (autocopyPrefs.getBoolPref("optStatusbarBlink")) {
		
		var focusedElement = document.commandDispatcher.focusedElement;
		if (focusedElement) {
			
			var SelectionLength = focusedElement.selectionEnd - focusedElement.selectionStart;
			Autocopy_DeselectAfterCopy_CollapseSelection_TextBox()
			setTimeout(Autocopy_DeselectAfterCopy_ExtendSelection_TextBox, 25, SelectionLength);
			setTimeout(Autocopy_DeselectAfterCopy_CollapseSelection_TextBox, 50);
			setTimeout(Autocopy_DeselectAfterCopy_ExtendSelection_TextBox, 75, SelectionLength);
			setTimeout(Autocopy_DeselectAfterCopy_CollapseSelection_TextBox, 100);
			
		} else {
			
			var focusedWindow = document.commandDispatcher.focusedWindow;
			try {
				var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
				var Selection = winWrapper.getSelection();
			} catch(e) {
				var Selection = focusedWindow.getSelection();
			}
			
			var SelectionfocusNode = Selection.focusNode;
			var SelectionfocusOffset = Selection.focusOffset;
			Autocopy_DeselectAfterCopy_CollapseSelection()
			setTimeout(Autocopy_DeselectAfterCopy_ExtendSelection, 25, SelectionfocusNode, SelectionfocusOffset);
			setTimeout(Autocopy_DeselectAfterCopy_CollapseSelection, 50);
			setTimeout(Autocopy_DeselectAfterCopy_ExtendSelection, 75, SelectionfocusNode, SelectionfocusOffset);
			setTimeout(Autocopy_DeselectAfterCopy_CollapseSelection, 100);
			
		}
		
	} else {
		
		var focusedElement = document.commandDispatcher.focusedElement;
		if (focusedElement) {
			Autocopy_DeselectAfterCopy_CollapseSelection_TextBox()
		} else {
			goDoCommand('cmd_selectNone');
		}
		
	}
	
}

function Autocopy_DeselectAfterCopy_ExtendSelection_TextBox(SelectionLength) {
	var focusedElement = document.commandDispatcher.focusedElement;
	if (focusedElement) {
		focusedElement.selectionEnd = focusedElement.selectionStart + SelectionLength;
	}
}

function Autocopy_DeselectAfterCopy_CollapseSelection_TextBox() {
	var focusedElement = document.commandDispatcher.focusedElement;
	if (focusedElement) {
		focusedElement.selectionEnd = focusedElement.selectionStart;
	}
}

function Autocopy_DeselectAfterCopy_ExtendSelection(SelectionfocusNode, SelectionfocusOffset) {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	try {
		var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
		var Selection = winWrapper.getSelection();
	} catch(e) {
		var Selection = focusedWindow.getSelection();
	}
	Selection.extend(SelectionfocusNode, SelectionfocusOffset);
}

function Autocopy_DeselectAfterCopy_CollapseSelection() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	try {
		var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
		var Selection = winWrapper.getSelection();
	} catch(e) {
		var Selection = focusedWindow.getSelection();
	}
	var SelectionanchorNode = Selection.anchorNode;
	var SelectionanchorOffset = Selection.anchorOffset;
	Selection.collapse(SelectionanchorNode, SelectionanchorOffset);
}

function AutocopyBlinkStatusbarButton(numberofblinks) {
	
	setTimeout(AutocopyBlinkStatusbarButton, 5000, 0); //resets in 5 seconds just incase
	if ((autocopyPrefs.getIntPref("StatusBarState") == 0) || (!autocopyPrefs.getBoolPref("optStatusBar"))) {
		return;
	}
	
	var button = document.getElementById('autocopy-status');
	var image = document.getElementById('autocopy-status-image');
	var tooltip = document.getElementById('autocopy-tooltip-value');
	
	if (numberofblinks <= 0) {
		image.setAttribute("src", "chrome://autocopy/skin/enabled.png");
		return;
	}
	
	if (image.getAttribute("src") == "chrome://autocopy/skin/enabled.png") {
		image.setAttribute("src", "chrome://autocopy/skin/blank.png");
	} else {
		image.setAttribute("src", "chrome://autocopy/skin/enabled.png");
	}
	
	numberofblinks = numberofblinks - 1;
	setTimeout(AutocopyBlinkStatusbarButton, 300, numberofblinks);
	
}

function autocopy_getSelection() {
	
	var SelectionText = "";
	var trywindow = false;

	var focusedElement = document.commandDispatcher.focusedElement;
	if (focusedElement && null != focusedElement) {
		try {
			SelectionText = focusedElement.value.substring(focusedElement.selectionStart, focusedElement.selectionEnd);
		} catch(e) {
			trywindow = true;
		}
	} else {
		trywindow = true;
	}

	if (trywindow) {
		var focusedWindow = document.commandDispatcher.focusedWindow;
		try {
			var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
			var Selection = winWrapper.getSelection();
		} catch(e) {
			var Selection = focusedWindow.getSelection();
		}
		SelectionText = Selection.toString();
	}
	
	return SelectionText;
	
}

function autocopy_getClipboardContents() {
	
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	if (!clip) return false;
	
	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return false;
	
	trans.addDataFlavor("text/unicode");
	clip.getData(trans, clip.kGlobalClipboard);
	var str = new Object();
	var strLength = new Object();
	
	try {
		trans.getTransferData("text/unicode", str, strLength);
	} catch (e) {
		return false;
	}
	
	if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) pastetext = str.data.substring(0,strLength.value / 2);
	
	return pastetext;
	
}

function autocopy_setClipboardContents(copytext) {
	
	try {
		
		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		if (!str) return false;
		str.data = copytext;
		
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		if (!trans) return false;
		
		trans.addDataFlavor("text/unicode");
		trans.setTransferData("text/unicode",str,copytext.length * 2);
		
		var clipid = Components.interfaces.nsIClipboard;
		var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
		if (!clip) return false;
		
		clip.setData(trans,null,clipid.kGlobalClipboard);
		return true;
		
	} catch(e) {
		return false;
	}
	
}

function autocopy_setClipboardContentsHtml(copyhtml, copytext) {
	
	try {
		
		var strhtml = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		if (!strhtml) return false;
		strhtml.data = copyhtml;
		
		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		if (!str) return false;
		str.data = copytext;
		
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		if (!trans) return false;
		
		trans.addDataFlavor("text/html");
		trans.setTransferData("text/html", strhtml, copyhtml.length * 2);
		trans.addDataFlavor("text/unicode");
		trans.setTransferData("text/unicode", str, copytext.length * 2);
		
		var clipid = Components.interfaces.nsIClipboard;
		var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
		if (!clip) return false;
		
		clip.setData(trans, null, clipid.kGlobalClipboard);
		autocopy_saveclipboard()
		return true;
		
	} catch(e) {
		return false;
	}
	
}

function autocopy_saveclipboard() {
	
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	if (!clip) return false;
	
	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return false;
	
	var importflavors = trans.flavorsTransferableCanImport();
	var exportflavors = trans.flavorsTransferableCanExport();
	
	trans.addDataFlavor("text/unicode");
	clip.getData(trans,clip.kGlobalClipboard);
	
	var dataType = new Object();
	var data = new Object();
	var dataLength = new Object();
	
	try {
		trans.getAnyTransferData(dataType, data, dataLength);
	} catch (e) {
		return false;
	}
	
	var contents = new AutocopyClipboardContents(dataType, data, dataLength);
	gautocopy_clipboardcontents.unshift(contents); //adds to the begining of array
	if (gautocopy_clipboardcontents.length > 10 + 1) {
		gautocopy_clipboardcontents.pop();  //remove last one if length to long
	}
	
	return true;
	
}

function autocopy_replaceoldclipboard(aIndex) {
	
	try {
		
		if (gautocopy_clipboardcontents[aIndex]) {
		
			if (autocopy_saveclipboard()) {
				aIndex = aIndex + 1;

				var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
				if (!trans) return false;

				trans.addDataFlavor(gautocopy_clipboardcontents[aIndex].dataType);
				trans.setTransferData(gautocopy_clipboardcontents[aIndex].dataType.value, gautocopy_clipboardcontents[aIndex].data.value, gautocopy_clipboardcontents[aIndex].dataLength.value);

				var clipid = Components.interfaces.nsIClipboard;
				var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
				if (!clip) return false;

				clip.setData(trans,null,clipid.kGlobalClipboard);

				if(aIndex > 1) {
					// move selected clipboardcontents to the begining of the clipboard array
					var autocopy_clipboardcontents = gautocopy_clipboardcontents[aIndex];
					gautocopy_clipboardcontents.splice(aIndex,1);
				}
				
				return true;
			} else {
				return false;
			}

		}
	} catch(e) {
		return false;
	}
}

function autocopy_pastetolocationbar() {
	
	var str = autocopy_getClipboardContents();
	if (!str) {
		return;
	}
	
	var urlbar = document.getElementById('urlbar');
	urlbar.value = str;
	urlbar.focus();
	
}

function autocopy_pastetosearchbar() {
	
	var str = autocopy_getClipboardContents();
	if (!str) {
		return;
	}
	
	var searchbar = document.getElementById('searchbar');
	if (!searchbar) {
		return;
	}
	
	if (searchbar.textbox.value) {
		searchbar.textbox.focus();
		searchbar.textbox.value = str;
	}
	
	if (searchbar.mTextbox.value) {
		searchbar.mTextbox.value = str;
		searchbar.mTextbox.focus();
	}
	
}

function autocopy_appendurltoclipboard() {
	
	var contents = autocopy_getClipboardContents();
	if (!contents) {
		return;
	}
	
	var copytext = contents + "\r\n\r\n" + window.content.location.href;
	autocopy_setClipboardContents(copytext);
	
}

function autocopy_timedhidemenu() {
	window.clearTimeout(gautocopy_hidemenu_timer);
	var timerinterval = autocopyPrefs.getIntPref("optContextMenuHideTimeout");
	if (timerinterval > 0) {
		gautocopy_hidemenu_timer = setTimeout("autocopy_hide_contextMenu();", timerinterval, 0);
	}
}

function autocopy_canceltimedhidemenu() {
	window.clearTimeout(gautocopy_hidemenu_timer);
}

function autocopy_hide_contextMenu() {
	document.getElementById('autocopy-context-menupopup-clipboards').hidePopup();
	document.getElementById('autocopy-context-menu').hidePopup();
}

function AutoCopy_searchForItems(itemid) {
	
	var strings = document.getElementById("autocopyStrings");
	var lcSearchFor = strings.getString('autocopy-context-menu-searchfor');
	var item = document.getElementById(itemid);
	if (!item) {
		return;
	}
	
	var SelectionText = autocopy_getSelection();
	if (!(SelectionText.length > 0) && gautocopy_lastSelection) {
		SelectionText = gautocopy_lastSelection;
	}
	
	if (SelectionText) {
		item.setAttribute('label', lcSearchFor + ' "' + SelectionText.substring(0, 12) + '..."');
	} else {
		item.setAttribute('label', lcSearchFor + ' ');
	}
	
}

function autocopy_contextmenu_onpopupshowing(e) {
	AutoCopy_searchForItems('autocopy-context-menu-searchforselection');
}

function autocopy_context_onpopupshowing(e) {
	AutoCopy_searchForItems('autocopy-context-searchforselection');
}

function AutoCopy_Clipboards_Handle(id) {
	
	var clipsmenu = document.getElementById(id);
	while (clipsmenu.childNodes.length > 0) {
		clipsmenu.removeChild(clipsmenu.childNodes[0]);
	}
	
	if (gautocopy_clipboardcontents.length == 0) {
		return false;
	}
	
	for (var x = 0; x < gautocopy_clipboardcontents.length & x < 10; x++) {
		
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		if (!trans) return false;
		
		trans.addDataFlavor(gautocopy_clipboardcontents[x].dataType.value);
		trans.setTransferData(gautocopy_clipboardcontents[x].dataType.value, gautocopy_clipboardcontents[x].data.value, gautocopy_clipboardcontents[x].dataLength.value);
		
		var str = new Object();
		var strLength = new Object();
		
		try{
			trans.getTransferData(gautocopy_clipboardcontents[x].dataType.value,str,strLength);
		} catch (e) {
			return false;
		}
		
		if (gautocopy_clipboardcontents[x].dataType.value == "text/unicode") {
			
			if (str) {
				str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
				pastetext = str.data.substring(0, strLength.value / 2);
			}
			
			var item = document.createElement('menuitem');
			item.setAttribute('oncommand', "autocopy_replaceoldclipboard(" + x + ");");
			item.setAttribute('label', pastetext.substring(0, 24));
			clipsmenu.appendChild(item);
			
		}
		
	}
	
}

function autocopy_context_menupopup_clipboards_onpopupshowing() {
	return AutoCopy_Clipboards_Handle('autocopy-context-menupopup-clipboards')
}

function autocopy_context_menupopup_clipboards2_onpopupshowing() {
	return AutoCopy_Clipboards_Handle('autocopy-context-menupopup-clipboards2')
}

function autocopy_searchforselection() {
	
	var SelectionText = autocopy_getSelection();
	if (!(SelectionText.length > 0) && gautocopy_lastSelection) {
		SelectionText = gautocopy_lastSelection;
	}
	
	// Apparently BrowserSearch and OpenSearch are magically available
	
	if (BrowserSearch) {
		BrowserSearch.loadSearch(SelectionText, true)
	} else {
		OpenSearch('internet', SelectionText, true);
	}
	
}

function autocopy_openinnewtab() {
	
	var SelectionText = autocopy_getSelection();
	if (!(SelectionText.length > 0) && gautocopy_lastSelection) {
		SelectionText = gautocopy_lastSelection;
	}
	
	window.gBrowser.addTab(SelectionText);
	
}
